#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <windows.h>


FILE *datei,*ziel;
int size,osize,lsize;
char *buffer;
char *symbol;
int i;

BOOL getLine()
{//liest eine ganze Zeile (bis '\n') aus der datei
  BYTE *zeichen;

  //lesepuffer fr ein zeichen anlegen und initialisieren
  zeichen = (BYTE *)malloc(sizeof(BYTE));
  *zeichen = '\0';

  //zeilenpuffer neu initialisieren
  *buffer = '\0';
  lsize = 0;

  //zeile (zeichenweise) aus der datei lesen... (abbrechen bei dateiende)
  if((fread(zeichen,sizeof(BYTE),1,datei)) == 0)
    return(false);

  while(*zeichen != '\n')
  {
    lsize++;
    buffer = (char *)realloc(buffer,lsize+1);
    strncat(buffer,(char *)zeichen,1);
    
    //nchstes zeichen lesen
    fread(zeichen,sizeof(BYTE),1,datei);
  }

  //das letzte zeichen noch anfgen
  lsize++;
  buffer = (char *)realloc(buffer,lsize+1);
  strncat(buffer,(char *)zeichen,1);


  i = 0;
  free(zeichen);
  return(true);
}


BOOL scanLine()
{//liefert alles zwischen doppeltabs bzw. zeilenende
  BYTE *zeichen;

  zeichen = (BYTE *)malloc(sizeof(BYTE));
  *zeichen = '\0';
  
  //puffer neu initialisieren
  *symbol = '\0';
  size = 0;

  //erstes zeichen einlesen
  *zeichen = (BYTE)(*(buffer+i));

  //abbruchbedingungen fr das einlesen
  while((*zeichen != '\t') && (i < lsize))
  {
    //zeichen im puffer zusammensetzen
    size++;
    symbol = (char *)realloc(symbol,size+1);
    strncat(symbol,(char *)zeichen,1);
    
    //nchstes zeichen lesen
    i++;
    *zeichen = (BYTE)(*(buffer+i));
  }

  //zweites tab bergehen
  i += 2;

  free(zeichen);
  return(true);
}


void int2string (int index,char *string)
{//String aus einem Integer generieren
	int r;
	char *temp;
	
	temp = string;
	
	r = (index / 1000) + 48;
	index = index % 1000;
	*temp++ = (char)r;
	
	r = (index / 100) + 48;
	index = index % 100;
	*temp++ = (char)r;

	r = (index / 10) + 48;
	index = index % 10;
	*temp++ = (char)r;
	
	*temp++ = (char)(index + 48);

	*temp = '\0';
}


int main(int argc, char* argv[])
{
  char *statement;
  char *zeit,*ozeit;
  char *quelle,*oquelle;
  char *methode;
  char *referenz;
  char *anzahl_string;
  int zsize=1,qsize=1,rsize,anzahl=0;
  int ozsize,oqsize,olsize;

	if(argc != 3)
  {
    printf("mehrfach <quelldatei> <zieldatei>");
    return(0);
  }

	printf("MEHRFACH...");

  //quelldatei zum lesen ffnen
	if((datei=fopen(argv[1],"r")) == NULL)
	{ 
    printf("Fehler beim ffnen der Datei %s\n",argv[1]);
		return(-1);
	}

  //zieldatei zum schreiben ffnen
	if((ziel=fopen(argv[2],"w")) == NULL)
	{ 
    printf("Fehler beim ffnen der Datei %s\n",argv[2]);
		return(-1);
	}

  //zeilenpuffer einrichten
  buffer = (char *)malloc(1);
  *buffer = '\0';

  //symbolpuffer einrichten
  symbol = (char *)malloc(1);
  *symbol = '\0';
 
  //initialisierung der vergleichsreferenz
  referenz = (char *)malloc(1);
  *referenz = '\0';

  ozeit = (char *)malloc(1);
  oquelle = (char *)malloc(1);

  while(getLine())
  {
    //vorhergehende zeit sichern und zeit neu einlesen
    scanLine();
    zsize = size;
    zeit = (char *)malloc(zsize+1);
    strncpy(zeit,symbol,zsize+1);

    //vorhergehenden dateinamen sichern und dateinamen neu einlesen
    scanLine();
    qsize = size;
    quelle = (char *)malloc(qsize+1);
    strncpy(quelle,symbol,qsize+1);

    //methodennamen einlesen
    scanLine();
    methode = (char *)malloc(size+1);
    strncpy(methode,symbol,size+1);

    if ((strcmp(methode,referenz)) != 0)
    {//nicht gleich => 
      //ausgabezeile zusammensetzen und in die ausgabedatei schreiben
      if(anzahl != 0)
      {
        statement = (char *)malloc(olsize+8);
        *statement = '\0';
        strncat(statement,ozeit,ozsize);
        strncat(statement,"\t\t",2);
        strncat(statement,oquelle,oqsize);
        strncat(statement,"\t\t",2);
        strncat(statement,"(",1);
        anzahl_string = (char *)malloc(1);
        *anzahl_string = '\0';
        int2string(anzahl,anzahl_string);
        strncat(statement,anzahl_string,4);
        strncat(statement,") ",2);
        strncat(statement,referenz,rsize);
        fwrite(statement,olsize+7,1,ziel);

        free(statement);

      }

      olsize = lsize;

      free(ozeit);
      ozsize = zsize;
      ozeit = (char *)malloc(ozsize+1);
      strncpy(ozeit,zeit,ozsize+1);

      free(oquelle);
      oqsize = qsize;
      oquelle = (char *)malloc(oqsize+1);
      strncpy(oquelle,quelle,oqsize+1);

      //neuen methodennamen als neue vergleichsreferenz sichern
      free(referenz);
      rsize = size;
      referenz = (char *)malloc(rsize+1);
      strncpy(referenz,methode,rsize+1);
      
      anzahl = 1;
    }
    else
    {//gleich => anzahl des aufeinanderfolgenden auftretens ermitteln
      anzahl++;
    }
    
    free(zeit);
    free(quelle);
    free(methode);
  }

  free(buffer);
  free(symbol);
  fclose(datei);
  fclose(ziel);
  
  printf("fertig\n");
  return (0);
}
